"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const util_1 = require("util");
const puppeteer_1 = __importDefault(require("puppeteer"));
class HeadlessEval {
    constructor(opts) {
        this.opts = optsWithDefaults((opts !== null && opts !== void 0 ? opts : {}));
    }
    async evalSnippet(url, snippet) {
        const browser = await puppeteer_1.default.launch();
        const page = await browser.newPage();
        try {
            return await this.doEvalSnippetInPage(page, url, snippet);
        }
        finally {
            await browser.close();
        }
    }
    async doEvalSnippetInPage(page, url, snippet) {
        await page.goto(url, {
            waitUntil: "networkidle2",
            timeout: 0,
        });
        const result = await page.evaluate(s => eval(s), snippet);
        const formattedResult = this.maybeSerialize(result);
        return formattedResult;
    }
    maybeSerialize(result) {
        if (this.opts.json)
            return JSON.stringify(result, undefined, '\t');
        if (util_1.isArray(result))
            return result.join('\n');
        return result;
    }
}
exports.default = HeadlessEval;
const defaultOpts = {
    json: false,
};
function optsWithDefaults(partialOpts) {
    return {
        ...defaultOpts,
        ...partialOpts,
    };
}
exports.optsWithDefaults = optsWithDefaults;
//# sourceMappingURL=lib.js.map